use gtk::gio::Icon;
use nucleo_matcher::Matcher;

pub mod desktop;

pub trait Module {
    fn results_for_search(&self, search: &str, matcher: &mut Matcher)
    -> Vec<Box<dyn SearchResult>>;
}

pub trait SearchResult {
    fn confidence(&self) -> u32;
    fn label(&self) -> String;
    fn description(&self) -> Option<String>;
    fn icon(&self) -> Option<Icon>;

    fn render_detail(&self, container: &gtk::Box);
    fn execute(&self);
}
